/*****************************************************
Project           : RadioPanel
Version           : 1.0.1
Date              : 20.06.2008
Author            : ***
Chip type         : ATtiny13
Clock frequency   : 128 kHz
*****************************************************/

#include <tiny13.h>

#define  AVC   PINB.0         // 
#define  SW    PINB.1         //  (,   )
#define  SEC   PINB.2         //    (,     )
#define  OUT   PORTB.3        //   ("1" -  , "0" -  )
#define  VCC   PORTB.4        //       ("0" -  )
long Freq = 128000;           //  (Hz)
int F=125;                    //   0 (Hz)      
int N=0;

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
   TCNT0=256-((Freq/1024)/F);       //  0   
   if (AVC==0) {                    //  
      if ((SW==0)&&(SEC==1)){          //  ,     
         OUT=1;                           //        
         N=0;
      }else if ((SW==0)&&(SEC==0)){ //      ...
         if (N<(5*125)){               // 5 ,  ...
            OUT=1;                        //    (    )
            VCC=0;                        // 
            N++;
         }else if(N<(15*125)){         //  10 ,  ...
            OUT=0;                        //   
            VCC=0;                        // 
            N++;
         }else if(N<(16*125)){         //  1 ,  ...
            OUT=1;                        //    (  )
            VCC=0;                        // 
            N++;
         }else{                        //   
            VCC=1;                        //  (GAME OVER)
         };
      }else if ((SW==1)&&(SEC==1)){ // ,     
         OUT=0;                        //   
         VCC=0;                        // ,    
      }else if ((SW==1)&&(SEC==0)){ // ,   
         VCC=1;                        //  (GAME OVER)
      };
   } else {                         //  
      VCC=0;                           // 
      OUT=0;                           //  
      N=0;
   };
}

void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// 
PORTB=0x16;
DDRB=0x18;

//    0
// Clock source: System Clock
// Clock value: 4,688 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x02;
TCCR0B=0x05;
TCNT0=256-((Freq/1024)/F);
OCR0A=0x00;
OCR0B=0x00;

//  
GIMSK=0x00;
MCUCR=0x00;

//  0
TIMSK0=0x02;

//  
ACSR=0x80;
ADCSRB=0x00;

//  
#asm("sei")

while (1)
   {
      // .
      //  -     0.
   };
}
